unit filedir;
{
ToDo:
  - Eckige Klammern und andere Sonderzeichen in Bauteilbezeichnung verhindern

}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, RegExpr,math,Contnrs, inifiles, FileCtrl, OleCtrls,
  SHDocVw, ExtCtrls, DatenbankEintrag,
  shellapi,

{
  ActiveX,  // IMalloc
  ShellAPI, // SHGetSpecialFolderLocation() und SHGetPathFromIDList()
  ShlObj,   // CSIDL_-Konstanten
}
  jpeg, ImgList, Menus
  ;

type

  TdbEintrag = class(Tobject)
  public
    Name:string;
    Beschreibung:String;
    lcName:string;
    lcBeschreibung:String;
    URL:String;
    PDF:String;
    pinout:string;
    inifilename:string;
  end;

  TFormFiledir = class(TForm)
    Panel1: TPanel;
    EditSuche: TEdit;
    Label1: TLabel;
    ButtonAlldatasheet: TButton;
    ImagePinout: TImage;
    PanelBrowse: TPanel;
    ListBoxGefunden: TListBox;
    Splitter1: TSplitter;
    WebBrowser1: TWebBrowser;
    Label2: TLabel;
    ButtonRefresh: TButton;
    Label3: TLabel;
    Timer1: TTimer;
    PopupMenu1: TPopupMenu;
    Datenbankeintrageditieren1: TMenuItem;
    Verzeichnisffnen1: TMenuItem;
    ImageList1: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure EditSucheChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListBoxGefundenMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ButtonAlldatasheetClick(Sender: TObject);
    procedure ImagePinoutClick(Sender: TObject);
    procedure Splitter1Moved(Sender: TObject);
    procedure ButtonRefreshClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ListBoxGefundenMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Datenbankeintrageditieren1Click(Sender: TObject);
    procedure Verzeichnisffnen1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    gefunden:Tstringlist;
    RegexExclude: TRegExpr;
    FileListfilename:string;
    countPinout:integer;
    countPDF:integer;

  public
    datenbank:Tobjectlist;
    filelist:Tstringlist;
    filenamelist:Tstringlist;
    ConfigFilePath:string;
    ConfigInifile:Tinifile;
    excludestring:string;
    procedure suchePfad(pattern:string; datenbasis:Tstringlist);
    procedure sucheDatei(pattern:string);
    procedure sucheInDB(pattern:string);
    procedure addToDb(filename:string);
    procedure FormularAusfuellen;
    procedure ListBoxGefundenDrawItem(Control: TWinControl; Index: Integer;
              area: TRect; State: TOwnerDrawState);
  end;

var
  FormFiledir: TFormFiledir;

implementation

{$R *.dfm}

(*
function GetSpecialFolder(hWindow: HWND; Folder: Integer): String;
{
CSIDL_COOKIES              Cookies
CSIDL_DESKTOPDIRECTORY     Desktop
CSIDL_FAVORITES            Favoriten
CSIDL_HISTORY              Internet-Verlauf
CSIDL_INTERNET_CACHE       "Temporary Internet Files"
CSIDL_PERSONAL             Eigene Dateien
CSIDL_PROGRAMS             "Programme" im Startmen
CSIDL_RECENT               "Dokumente" im Startmen
CSIDL_SENDTO               "Senden an" im Kontextmen
CSIDL_STARTMENU            Startmen
CSIDL_STARTUP              Autostart
}
var
  pMalloc: IMalloc;
  pidl: PItemIDList;
  Path: PChar;
begin
  // get IMalloc interface pointer
  if (SHGetMalloc(pMalloc) <> S_OK) then
  begin
    MessageBox(hWindow, 'Couldn''t get pointer to IMalloc interface.',
               'SHGetMalloc(pMalloc)', 16);
    Exit;
  end;

  // retrieve path
  SHGetSpecialFolderLocation(hWindow, Folder, pidl);
  GetMem(Path, MAX_PATH);
  SHGetPathFromIDList(pidl, Path);
  Result := Path;
  FreeMem(Path);

  // free memory allocated by SHGetSpecialFolderLocation
  pMalloc.Free(pidl);
end;
*)
//------------------------------------------------------------------------------
function getIniFilename(basedir:string):string;
var
  sr:   TSearchRec;
begin
  if directoryExists(BaseDir) then begin
    if FindFirst(BaseDir+'*_z.ini', faAnyFile, sr) = 0 then begin
      result:=BaseDir+sr.Name;
    end else result:=BaseDir+'datenblatt_z.ini';
  end;
end;

//------------------------------------------------------------------------------
procedure getFileList(BaseDir: String; FilePattern:string; var FileList:Tstringlist);
var
  sr:   TSearchRec;
begin
  if directoryExists(BaseDir) then begin
    if FindFirst(BaseDir+FilePattern, faAnyFile, sr) = 0 then begin
      // berspringe die Pseudo-Directories
      if ((sr.Name <> '.') and (sr.Name <> '..')) then begin
        // nur Dateien
        if (sr.Attr and faDirectory) = 0 then begin
            FileList.Add(lowercase(BaseDir+sr.Name));
        end else begin
          getFileList(BaseDir+sr.Name+'\', FilePattern, FileList);
        end;
      end;
      while FindNext(sr) = 0 do begin
        // berspringe die Pseudo-Directories
        if ((sr.Name <> '.') and (sr.Name <> '..')) then begin
          // nur Dateien
          if (sr.Attr and faDirectory) = 0 then begin
            FileList.Add(lowercase(BaseDir+sr.Name));
          end else begin
            getFileList(BaseDir+sr.Name+'\', FilePattern, FileList);
          end;
        end;
      end;
    end;
    SysUtils.FindClose(sr);
  end;
end;


//------------------------------------------------------------------------------
procedure TFormFiledir.addToDb(filename:string);
//Alle Eintrge der INI-Datei zur Datenbank hinzufgen
var
  i:integer;
  sections:Tstrings;
  inifile:Tmeminifile;
  dbEintrag: TdbEintrag;
  pfad, pdf:string;
begin
  sections:=Tstringlist.Create;
  inifile:=Tmeminifile.Create(filename);
  inifile.ReadSections(sections);
  pfad:=ExtractFilePath(inifile.FileName);
  for i:=0 to sections.Count-1 do begin
    dbEintrag:=TdbEintrag.Create;
    dbEintrag.Name:=sections[i];
    dbEintrag.Beschreibung:=inifile.readString(sections[i],'descr','-?-');
    dbEintrag.lcName:=lowercase(dbEintrag.Name);
    dbEintrag.lcBeschreibung:=lowercase(dbEintrag.Beschreibung);
    dbEintrag.pinout:=inifile.readString(sections[i],'pinout','');
    if length(dbEintrag.pinout)>0
    then begin
      inc(countPinout);
    end;
    dbEintrag.url:=inifile.readString(sections[i],'url','');
    dbEintrag.inifilename:=inifile.FileName;
    pdf:=inifile.readString(sections[i],'pdf','');
    if length(pdf)>0
    then begin
      dbEintrag.pdf:=pfad+inifile.readString(sections[i],'pdf','');
      inc(countPDF);
    end;

    datenbank.Add(dbEintrag);
  end;
  inifile.free;
end;

//------------------------------------------------------------------------------
procedure TFormFiledir.EditSucheChange(Sender: TObject);
begin
  sucheInDB(EditSuche.Text);
  sucheDatei(EditSuche.Text);
  suchePfad(EditSuche.Text, filelist);
  ListBoxGefunden.clear;
  ListBoxGefunden.Items.AddStrings(gefunden);
end;
//------------------------------------------------------------------------------
procedure TFormFiledir.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ConfigInifile.WriteInteger('Form','Splitterpos',ListBoxGefunden.Width);
  ConfigInifile.WriteInteger('Form','width',Width);
  ConfigInifile.WriteInteger('Form','height',height);
  ConfigInifile.WriteInteger('Form','top',top);
  ConfigInifile.WriteInteger('Form','left',left);

  ConfigInifile.UpdateFile;
  ConfigInifile.free;
end;

//------------------------------------------------------------------------------
procedure TFormFiledir.FormCreate(Sender: TObject);
var
  pfad:string;
  Regex: TRegExpr;
  i,n:integer;
begin
  datenbank:=Tobjectlist.Create;


  //Konfigdateien knnen neben der .exe liegen, oder in c:\DokumenteUndEinstellungen\_Anwender_\LokaleEinstellungen\Zabex\...
  pfad:=ExtractFilePath(Application.exename);

//  Attrs := FileGetAttr(pfad);
{
  if fileexists(pfad+'\USE_LOCAL_APPDAT.aha') then begin
    ConfigFilePath:=GetSpecialFolder(handle,CSIDL_LOCAL_APPDATA)+'\Zabex\';
    ForceDirectories(ConfigFilePath);
  end else begin
}
    ConfigFilePath:=pfad;
//  end;


  gefunden:=Tstringlist.create;
  countPinout:=0;
  countPDF:=0;     

  ConfigInifile:=TInifile.Create(ConfigFilePath+'datasheet_config.ini');
  excludestring:=ConfigInifile.ReadString('Exclude','Pattern','_z\.ini$');
  ConfigInifile.writeString('Statistic','LastStart',dateTimeToStr(now));

  if not ConfigInifile.SectionExists('Exclude')
  then ConfigInifile.writeString('Exclude','Pattern','(_z\.ini$)|(~$)');

  //Liste der Filenamen einlesen
  filelist:=Tstringlist.Create;
  filenamelist:=Tstringlist.Create;
  filenamelist.Sorted:=false;
  FileListfilename:=ConfigFilePath+'filelist.txt';
  if fileexists(FileListfilename)
  then filelist.LoadFromFile(FileListfilename)
  else begin
    getFileList(pfad,'*', filelist);
    filelist.SaveToFile(FileListfilename);
    ConfigInifile.writeString('Statistic','LastRefresh',dateTimeToStr(now));
  end;

  //Filenamen aus Fileliste extrahieren
  for i:=0 to filelist.count-1 do begin
    filenamelist.Add(extractfilename(filelist[i]));
  end;
  ConfigInifile.writeInteger('Statistic','FilesInFileList',filelist.count);

  // INI-Dateien suchen
  Regex:=TRegExpr.Create;
  Regex.Expression:='_z\.ini$';
  Regex.ModifierI:=true;
  Regex.Compile;
  n:=0;
  for i:=0 to filelist.count-1 do begin
    if regex.exec(filelist[i]) then begin
      addToDb(filelist[i]);
      inc(n);
    end;
  end;
  Regex.free;

  //Statistiken schreiben
  ConfigInifile.writeInteger('Statistic','Ini_Files',n);
  ConfigInifile.writeInteger('Statistic','EntriesInIniFiles',datenbank.Count);
  ConfigInifile.writeInteger('Statistic','PdfInIniFiles',countPDF);
  ConfigInifile.writeInteger('Statistic','PinoutInIniFiles',countPinout);

  //Exclude
  RegexExclude:=TRegExpr.Create;
  RegexExclude.Expression:=excludestring;
  RegexExclude.ModifierI:=true;
  RegexExclude.Compile;

  ListBoxGefunden.OnDrawItem:=ListBoxGefundenDrawItem;
  ListBoxGefunden.Style:=lbOwnerDrawFixed;
end;


//------------------------------------------------------------------------------
procedure TFormFiledir.sucheDatei(pattern:string);
var
  Regex:TregExpr;
  i:integer;
  expr:string;
  delta,fern:integer;
  p,q:integer;
  zeile:string;
  ergebnis:Tstringlist;
  key:string;
  zeichen:char;
begin
  if length(pattern)>0 then begin

    expr:='.*';
    pattern:=lowercase(pattern);
    for i:=1 to length(pattern) do begin
      expr:=expr+pattern[i]+'.*';
    end;

    ergebnis:=Tstringlist.Create;
    ergebnis.Sorted:=true;
    Regex:=TRegExpr.Create;
    Regex.Expression:=expr;
//    Regex.ModifierI:=true;
    Regex.Compile;
    delta:=0;
    zeichen:=#0;
    for i:=0 to filenamelist.count-1 do begin
      if Regex.Exec(filenamelist[i]) then begin
        zeile:=filenamelist[i];
        if not RegexExclude.exec(zeile) then begin
          p:=pos(pattern[1],zeile);
          if (p>0) then begin
            q:=1;
            fern:=0;
            while (p <= length(zeile)) and (q <= length(pattern)) do begin

              if zeile[p] = pattern[q] then begin
                inc(fern,delta);
                delta:=0;
                zeichen:=pattern[q];
                inc(q);
              end else begin
                if zeile[p] = zeichen then begin
                  delta:=0;
                end else begin
                  inc(delta);
                end;
              end;
              inc(p);
            end;
          end
          else fern:=600;
          key:=chr(65+fern div 26)+chr(65+fern mod 26);
          ergebnis.add(key+':'+filelist[i]); //<<-- nicht filenamelist!
        end;
      end;
    end;
    for i:=0 to min(ergebnis.Count-1, 30)
    do gefunden.add(copy(ergebnis[i],4,299));
    ergebnis.Free;
    Regex.free;
  end;
end;


//------------------------------------------------------------------------------
procedure TFormFiledir.suchePfad(pattern: string; datenbasis: Tstringlist);
var
  i:integer;
  fern:integer;
  zeile:string;
  ergebnis:Tstringlist;
  key:string;
begin
  if length(pattern)>0 then begin
    pattern:=lowercase(pattern);
    ergebnis:=Tstringlist.Create;
    ergebnis.Sorted:=true;
    for i:=0 to datenbasis.count-1 do begin
      fern:= pos(pattern, datenbasis[i]);
      if fern >0 then begin
        zeile:=datenbasis[i];
        if not RegexExclude.exec(zeile) then begin
          key:=chr(65+fern div 26)+chr(65+fern mod 26);
          ergebnis.add(key+':'+datenbasis[i]);
        end;
      end;
    end;
    for i:=0 to min(ergebnis.Count-1, 30)
    do gefunden.add(copy(ergebnis[i],4,299));
    ergebnis.Free;
  end;
end;


//------------------------------------------------------------------------------
procedure TFormFiledir.sucheInDB(pattern: string);
var
  Regex:TregExpr;
  i:integer;
  expr:string;
  delta,fern:integer;
  p,q:integer;
  zeile:string;
  ergebnis:Tstringlist;
  key:string;
  zeichen:char;
begin
  gefunden.Clear;
  if length(pattern) < 1 then exit;
  pattern:=lowercase(pattern);

  expr:='.*';
  for i:=1 to length(pattern) do begin
    expr:=expr+pattern[i]+'.*';
  end;

  ergebnis:=Tstringlist.Create;
  ergebnis.Sorted:=true;
  Regex:=TRegExpr.Create;
  Regex.Expression:=expr;
  //Regex.ModifierG:=true;
  Regex.Compile;
  for i:=0 to datenbank.count-1 do begin
//    if (unterbreche<>0) then exit;
    p:=pos(pattern, (datenbank[i] as TdbEintrag).lcBeschreibung);
    if (p>0) then begin
        key:='00>';
        ergebnis.addObject(key+(datenbank[i] as TdbEintrag).Name+' : '
                  +(datenbank[i] as TdbEintrag).Beschreibung,
                           datenbank[i]);
    end else begin
      if Regex.Exec(lowercase((datenbank[i] as TdbEintrag).lcName)) then begin

        zeile:=(datenbank[i] as TdbEintrag).lcName;
        p:=max(1,pos(pattern[1],zeile));
        q:=1;
        fern:=0;
        delta:=0;
        zeichen:=#8;
        while (p <= length(zeile)) and (q <= length(pattern)) do begin
          if zeile[p] = pattern[q] then begin
            inc(fern,delta);
            delta:=0;
            zeichen:=pattern[q];
            inc(q);
          end else begin
            if zeile[p] = zeichen then begin
              delta:=0;
            end else begin
              inc(delta);
            end;
          end;
          inc(p);

        end;
        key:=chr(65+fern div 26)+chr(65+fern mod 26);
        ergebnis.addObject(key+':'+(datenbank[i] as TdbEintrag).Name+' : '+
                          (datenbank[i] as TdbEintrag).Beschreibung,
                           datenbank[i]);
      end;
    end;
  end;
  for i:=0 to min(ergebnis.Count-1, 30)
  do gefunden.addObject(copy(ergebnis[i],4,299),ergebnis.Objects[i] );
  ergebnis.Free;
  Regex.free;
end;


//------------------------------------------------------------------------------
procedure TFormFiledir.FormShow(Sender: TObject);
begin
  EditSuche.SetFocus;
end;

//------------------------------------------------------------------------------
procedure TFormFiledir.ListBoxGefundenMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  imgpfad:string;
  pinoutfilename:string;
begin
  if ListBoxGefunden.ItemIndex < 0 then exit;
  if  (ssAlt in Shift)  then begin
    //Datenbankeintrag zeigen oder anlegen
    FormularAusfuellen;
  end else
  if (not (ssCtrl in Shift)) and (x>=20)   then begin
    //PDF anzeigen
    if assigned(gefunden.Objects[ListBoxGefunden.ItemIndex]) then begin
      webbrowser1.Navigate((gefunden.Objects[ListBoxGefunden.ItemIndex] as TdbEintrag).pdf );
    end else begin
      webbrowser1.Navigate(gefunden[ListBoxGefunden.ItemIndex]);
    end;
  end else begin
    //pinout anzeigen
    if assigned(gefunden.Objects[ListBoxGefunden.ItemIndex]) then begin
      if length((gefunden.Objects[ListBoxGefunden.ItemIndex] as TdbEintrag).pinout)>3
      then begin
//        webbrowser1.Navigate((gefunden.Objects[ListBoxGefunden.ItemIndex] as TdbEintrag).pinout );
        try
          imgpfad:=extractfilepath((gefunden.Objects[ListBoxGefunden.ItemIndex] as TdbEintrag).inifilename);
          pinoutfilename:=(gefunden.Objects[ListBoxGefunden.ItemIndex] as TdbEintrag).pinout;
          imagePinout.Picture.LoadFromFile(imgpfad + pinoutfilename);
          panelBrowse.visible:=false;
          imagePinout.visible:=true;
          Color := $ffe0d0; //Hintergrund auf Blau setzen

        except
            on EInvalidGraphic do begin
              imagePinout.Picture.Graphic := nil;
              panelBrowse.visible:=true;
            end else
            panelBrowse.visible:=true;
        end;

      end else webbrowser1.Navigate((gefunden.Objects[ListBoxGefunden.ItemIndex] as TdbEintrag).pdf );
    end else begin
      webbrowser1.Navigate(gefunden[ListBoxGefunden.ItemIndex]);
    end;
  end;
end;

//------------------------------------------------------------------------------
procedure TFormFiledir.Splitter1Moved(Sender: TObject);
begin
  ListBoxGefunden.Repaint;
  WebBrowser1.Repaint;
end;


//------------------------------------------------------------------------------
procedure TFormFiledir.ButtonAlldatasheetClick(Sender: TObject);
var
  a,b,z,path:string;
  t:textfile;
begin
  a:='<html><body><form onsubmit="this.action=''http://www.alldatasheet.com/view.jsp?sSearchword=''';
  b:='+this.sSearchword.value;" method="post" target="_blank">  <h2>Suche auf www.alldatasheet.com:</h2><input type="text" size="11" name="sSearchword" value="';
  z:='" ><input type="submit" value="Suchen"><input type="hidden" name="sChk"></form></body></html>';
  path:=ExtractFilePath(application.exename);
  assignfile(t,'alldatasheet.html');
  rewrite(t);
  write(t,a);
  write(t,b);
  write(t,EditSuche.text);
  writeln(t,z);
  closefile(t);
  webbrowser1.Navigate(ExtractFilePath(application.exename) + 'alldatasheet.html');
end;

//------------------------------------------------------------------------------
procedure TFormFiledir.ButtonRefreshClick(Sender: TObject);
var
  pfad:string;
  Tempfilelist:Tstringlist;
begin
  buttonRefresh.caption:='Geduld...';
  buttonRefresh.enabled:=false;
  Application.ProcessMessages;

  pfad:=ExtractFilePath(Application.exename);
  Tempfilelist:=Tstringlist.create;
  getFileList(pfad,'*', Tempfilelist);
  Tempfilelist.SaveToFile(FileListfilename);
  filelist.clear;
  filelist.AddStrings(Tempfilelist);
  Tempfilelist.free;
  buttonRefresh.caption:='Refresh';
  buttonRefresh.enabled:=true;
  ConfigInifile.writeString('Statistic','LastRefresh',dateTimeToStr(now));
  EditSuche.SetFocus;
end;

//------------------------------------------------------------------------------
procedure TFormFiledir.FormularAusfuellen;
var
  eintrag:TdbEintrag;
  inifile:Tinifile;
  section:string;
  iniFileName:string;
  pdf:string;
  basedir:string;
  bauteilName:string;
  dbEintrag:TdbEintrag;
begin
  if assigned(gefunden.Objects[ListBoxGefunden.ItemIndex]) then begin
    eintrag:=gefunden.Objects[ListBoxGefunden.ItemIndex] as TdbEintrag;
    FormDatenbankeintrag.EditBauteil.Text:=eintrag.Name;
    FormDatenbankeintrag.EditBeschreibung.Text:=eintrag.Beschreibung;
    FormDatenbankeintrag.EditDatenblatt.Text:=extractFilename(eintrag.PDF);
    FormDatenbankeintrag.EditAnschluss.Text:=eintrag.pinout;
    FormDatenbankeintrag.EditURL.Text:=eintrag.URL;
    FormDatenbankeintrag.LabelInifile.caption:=eintrag.inifilename;
    FormDatenbankeintrag.Pfad:=extractFilepath(eintrag.PDF);
    if fileexists(FormDatenbankeintrag.Pfad + eintrag.pinout)
    then begin
      FormDatenbankeintrag.image1.Picture.LoadFromFile(FormDatenbankeintrag.Pfad + eintrag.pinout);
      FormDatenbankeintrag.image1.Visible:=true;
    end else FormDatenbankeintrag.image1.Visible:=false;
    if mrOK = FormDatenbankeintrag.showmodal then begin
      section:=FormDatenbankeintrag.EditBauteil.Text;
      inifile:=Tinifile.Create(FormDatenbankeintrag.LabelInifile.caption);
      inifile.WriteString(section,'Descr',FormDatenbankeintrag.EditBeschreibung.Text);
      inifile.WriteString(section,'PDF',FormDatenbankeintrag.EditDatenblatt.Text);
//      inifile.WriteString(section,'pinout',FormDatenbankeintrag.Pfad+FormDatenbankeintrag.EditAnschluss.Text);
      inifile.WriteString(section,'pinout',FormDatenbankeintrag.EditAnschluss.Text);
      inifile.WriteString(section,'URL',FormDatenbankeintrag.EditURL.Text);

      eintrag.Beschreibung:=FormDatenbankeintrag.EditBeschreibung.Text;
      eintrag.pinout:=FormDatenbankeintrag.EditAnschluss.Text;
      eintrag.URL:=FormDatenbankeintrag.EditURL.Text;
      eintrag.PDF:=extractFilename(FormDatenbankeintrag.EditDatenblatt.Text);
    end;
  end else begin
    //neuen Eintrag anlegen
     pdf:=gefunden[ListBoxGefunden.ItemIndex];
     basedir:=ExtractFilePath(pdf);
    //Gibt's in dem PDF-Verzeichnis schon eine *_z.ini Datei?
    //Sonst: nimm den Defaultnamen
    iniFileName:=getIniFilename(basedir);
    FormDatenbankeintrag.LabelInifile.caption:=iniFileName;

    //Neue Datei anlegen
    bauteilName:=trim(ChangeFileExt(ExtractFileName(pdf),''));
    FormDatenbankeintrag.EditBauteil.Text:=bauteilName;
    FormDatenbankeintrag.Pfad:=basedir;
    section:=bauteilName;
    inifile:=Tinifile.Create(iniFileName);
    FormDatenbankeintrag.EditBeschreibung.Text:= inifile.ReadString(section,'Descr','');
    FormDatenbankeintrag.EditDatenblatt.Text:=ExtractFileName(pdf);
    FormDatenbankeintrag.EditAnschluss.Text:=inifile.ReadString(section,'pinout','');
    FormDatenbankeintrag.EditURL.Text:=inifile.ReadString(section,'URL','');
    FormDatenbankeintrag.LabelInifile.caption:=inifilename;
    FormDatenbankeintrag.image1.Visible:=false;
    inifile.free;
    if mrOK = FormDatenbankeintrag.showmodal then begin
      section:=FormDatenbankeintrag.EditBauteil.Text;
      inifile:=Tinifile.Create(FormDatenbankeintrag.LabelInifile.caption);
      inifile.WriteString(section,'Descr',FormDatenbankeintrag.EditBeschreibung.Text);
      inifile.WriteString(section,'PDF',FormDatenbankeintrag.EditDatenblatt.Text);
      inifile.WriteString(section,'pinout',FormDatenbankeintrag.EditAnschluss.Text);
      inifile.WriteString(section,'URL',FormDatenbankeintrag.EditURL.Text);
      inifile.UpdateFile;
      inifile.free;

      if filelist.indexof(FormDatenbankeintrag.LabelInifile.caption) < 0
      then begin
        filelist.Add(FormDatenbankeintrag.LabelInifile.caption);
        filelist.SaveToFile(FileListfilename);
      end;

      //Datenbankeintrag hinzufgen
      dbEintrag:=TdbEintrag.Create;
      dbEintrag.Name:=section;
      dbEintrag.Beschreibung:=FormDatenbankeintrag.EditBeschreibung.Text;
      dbEintrag.lcName:=lowercase(dbEintrag.Name);
      dbEintrag.lcBeschreibung:=lowercase(dbEintrag.Beschreibung);
      dbEintrag.pinout:=FormDatenbankeintrag.EditAnschluss.Text;
      dbEintrag.url:=FormDatenbankeintrag.EditURL.Text;
      dbEintrag.inifilename:=FormDatenbankeintrag.LabelInifile.caption;
      dbEintrag.pdf:=extractFilepath(FormDatenbankeintrag.LabelInifile.caption) +
                     FormDatenbankeintrag.EditDatenblatt.Text;
      datenbank.Add(dbEintrag);
    end;
  end;
end;



//------------------------------------------------------------------------------
procedure TFormFiledir.ImagePinoutClick(Sender: TObject);
begin
   panelBrowse.visible:=true;
   imagePinout.visible:=false;
end;

//------------------------------------------------------------------------------
procedure TFormFiledir.ListBoxGefundenDrawItem(Control: TWinControl;
  Index: Integer; area: TRect; State: TOwnerDrawState);
var
  txt:String;
  txtwidth:integer;
  listwidth:integer;
  x:integer;
begin
  with (Control as TListbox) do
  begin
    if odSelected in State then //Prft, ob ein Item markiert ist
      Canvas.Brush.Color := clRed //Canvas-Hintergrundfarbe auf Rot setzen
    else begin
      if (Index and 1) =0
      then Canvas.Brush.Color := $ffffff //Canvas-Hintergrundfarbe auf wei setzen
      else Canvas.Brush.Color := $e0ffe0; //Canvas-Hintergrundfarbe auf hellgrn setzen

    end;

    Canvas.FillRect(area); //schn ausmalen
    txt:=Items[Index];
    txtwidth:=canvas.TextWidth(txt);
    listwidth:=area.right-area.Left - 20;
    x:=listwidth- txtwidth;
    Canvas.TextOut(x+16, area.Top, Items[Index]); //Text drberpinseln

    Canvas.Brush.Color := $e0e0e0; //Canvas-Hintergrundfarbe auf Hell setzen
    Canvas.FillRect(Rect(area.Left,area.Top,area.Left+19, area.bottom)); //schn ausmalen
    if assigned(gefunden.Objects[Index]) then begin
      if length((gefunden.Objects[Index] as TdbEintrag).pinout)>3
      then begin
        Canvas.Brush.Color := $ff6060; //Marke auf Blau setzen
        Canvas.FillRect(Rect(area.Left+2,area.Top+2,area.Left+19-2, area.bottom-2)); //Icon links malen
      end;
    end;
  end;
end;

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
procedure TFormFiledir.Timer1Timer(Sender: TObject);
begin
  Width:=ConfigInifile.ReadInteger('Form','width',888);
  height:=ConfigInifile.ReadInteger('Form','height',700);
  top:=ConfigInifile.ReadInteger('Form','top',10);
  left:=ConfigInifile.ReadInteger('Form','left',10);
  ListBoxGefunden.Width:=ConfigInifile.ReadInteger('Form','Splitterpos',400);
  timer1.enabled:=false;
end;

//------------------------------------------------------------------------------
procedure TFormFiledir.FormActivate(Sender: TObject);
begin
  EditSuche.SetFocus;
end;

//------------------------------------------------------------------------------
procedure TFormFiledir.ListBoxGefundenMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  n:integer;
begin
  if Button=mbRight then begin
    n:=ListBoxGefunden.ItemAtPos(point(x,y),true);
    if n>=0 then begin
      ListBoxGefunden.ItemIndex:=n;
      popupmenu1.AutoPopup:=true;
    end else begin
      popupmenu1.AutoPopup:=false;
    end;
  end;
end;

//------------------------------------------------------------------------------
procedure TFormFiledir.Datenbankeintrageditieren1Click(Sender: TObject);
begin
  FormularAusfuellen;
end;

//------------------------------------------------------------------------------
procedure TFormFiledir.Verzeichnisffnen1Click(Sender: TObject);
var
  eintrag:TdbEintrag;
  pfad:string;
  datei:string;
begin

  if assigned(gefunden.Objects[ListBoxGefunden.ItemIndex]) then begin
    eintrag:=gefunden.Objects[ListBoxGefunden.ItemIndex] as TdbEintrag;
    datei:=eintrag.PDF;
    pfad:=extractFilepath(datei);

//    ShellExecute(handle, 'open', pchar(extractFilepath(eintrag.PDF)), nil,nil, SW_SHOWNORMAL);
    ShellExecute(Handle, nil, 'Explorer.exe', pchar('/e,/select,'+datei), PChar(pfad), SW_NORMAL);
  end else begin
    datei:=ListBoxGefunden.Items[ListBoxGefunden.ItemIndex];
    pfad:=extractFilepath(datei);
    if DirectoryExists(pfad) then begin
      ShellExecute(Handle, nil, 'Explorer.exe', pchar('/e,/select,'+datei), PChar(pfad), SW_NORMAL);
    end;
  end;
end;

//------------------------------------------------------------------------------

(*

ShellExecute(Handle, nil, 'Explorer.exe', '/n,/e,', PChar(CurrentDir), SW_NORMAL);


   -------------------
C:\WINDOWS\explorer.exe /e, D:
------------


Explorer /e,[Laufwerk]:\[Pfad]

z.B.Explorer /e,C:\windows

ab Windows XP geht auch: Explorer C:\,/e



Wollen Sie nur den Explorer ffnen, ohne dass ein Verzeichnis geffnet wird, mssen Sie folgenden Aufruf benutzen:

Explorer /e,/select



Syntax:

Explorer [/n] [/e][,/root,object][[,/select],subobject]



Parameter:

/root,object


Wenn Sie diesen Parameter angeben, wird der Pfad im Explorer als Root angezeigt (Sie knnen nicht weiter * blttern)

Beispiel: Explorer /e,/root,c:\windows\system

/e


Auf der linken Seite wird ein Verzeichnisbaum angezeigt. Wenn Sie diesen Parameter weglassen, wird im Explorer nur der Ordnerinhalt angezeigt.

/n


ffnet immer einen neuen Explorer, auch wenn schon einer geffnet ist.

subobject


Legt den Ordner fest, der den FOCUS erhlt, wenn der Explorer gestartet wird. Als Standard ist root definiert.

Das ist nicht in Verbindung mit /SELECT mglich

/select


Legt fest, dass ein Ordner geffnet wird und ein Objekt im Ordner selektiert ist



InfoUnter Windows 2000 mssen Sie hinter "/select" noch ein Komma setzen, also
"Explorer /e,/select," bzw. "Explorer /e,/select,C:", ansonsten kommt es zu einem Absturz.
*)

end.
